# SPDX-FileCopyrightText: 2020 - 2022 Aaron Raimist
# SPDX-FileCopyrightText: 2020 - 2024 MDAD project contributors
# SPDX-FileCopyrightText: 2020 - 2025 Slavi Pantaleev
# SPDX-FileCopyrightText: 2020 Dan Arnfield
# SPDX-FileCopyrightText: 2021 Ahmad Haghighi
# SPDX-FileCopyrightText: 2021 Paul Tötterman
# SPDX-FileCopyrightText: 2022 - 2023 Julian-Samuel Gebühr
# SPDX-FileCopyrightText: 2022 - 2025 Nikita Chernyi
# SPDX-FileCopyrightText: 2022 Christos Karamolegkos
# SPDX-FileCopyrightText: 2022 Joe Kappus
# SPDX-FileCopyrightText: 2022 Marko Weltzer
# SPDX-FileCopyrightText: 2023 Igor Goldenberg
# SPDX-FileCopyrightText: 2023 Pierre 'McFly' Marty
# SPDX-FileCopyrightText: 2023 Samuel Meenzen
# SPDX-FileCopyrightText: 2024 Suguru Hirahara
#
# SPDX-License-Identifier: AGPL-3.0-or-later

---
# Project source code URL: https://github.com/element-hq/element-web

matrix_client_element_enabled: true

matrix_client_element_container_image_self_build: false
matrix_client_element_container_image_self_build_repo: "https://github.com/element-hq/element-web.git"
# Controls whether to patch webpack.config.js when self-building, so that building can pass on low-memory systems (< 4 GB RAM):
# - https://github.com/spantaleev/matrix-docker-ansible-deploy/issues/1357
# - https://github.com/element-hq/element-web/issues/19544
matrix_client_element_container_image_self_build_low_memory_system_patch_enabled: "{{ ansible_memtotal_mb < 4096 }}"

# renovate: datasource=docker depName=ghcr.io/element-hq/element-web
matrix_client_element_version: v1.12.2

matrix_client_element_docker_image: "{{ matrix_client_element_docker_image_registry_prefix }}element-hq/element-web:{{ matrix_client_element_version }}"
matrix_client_element_docker_image_registry_prefix: "{{ 'localhost/' if matrix_client_element_container_image_self_build else matrix_client_element_docker_image_registry_prefix_upstream }}"
matrix_client_element_docker_image_registry_prefix_upstream: "{{ matrix_client_element_docker_image_registry_prefix_upstream_default }}"
matrix_client_element_docker_image_registry_prefix_upstream_default: ghcr.io/
matrix_client_element_docker_image_force_pull: "{{ matrix_client_element_docker_image.endswith(':latest') }}"

matrix_client_element_data_path: "{{ matrix_base_data_path }}/client-element"
matrix_client_element_docker_src_files_path: "{{ matrix_client_element_data_path }}/docker-src"

# The base container network
matrix_client_element_container_network: ''

# A list of additional container networks that the container would be connected to.
# The role does not create these networks, so make sure they already exist.
# Use this to expose this container to a reverse proxy, which runs in a different container network.
matrix_client_element_container_additional_networks: []

# Controls the in-container port that Element will use.
#
# Also see: `matrix_client_element_container_http_host_bind_port`
matrix_client_element_container_port: 8080

# Controls whether the matrix-client-element container exposes its HTTP port (tcp/8080 in the container).
#
# Takes an "<ip>:<port>" or "<port>" value (e.g. "127.0.0.1:8765"), or empty string to not expose.
#
# Also see: `matrix_client_element_container_port`
matrix_client_element_container_http_host_bind_port: ''

# matrix_client_element_container_labels_traefik_enabled controls whether labels to assist a Traefik reverse-proxy will be attached to the container.
# See `../templates/labels.j2` for details.
#
# To inject your own other container labels, see `matrix_client_element_container_labels_additional_labels`.
matrix_client_element_container_labels_traefik_enabled: true
matrix_client_element_container_labels_traefik_docker_network: "{{ matrix_client_element_container_network }}"
matrix_client_element_container_labels_traefik_hostname: "{{ matrix_client_element_hostname }}"
# The path prefix must either be `/` or not end with a slash (e.g. `/element`).
matrix_client_element_container_labels_traefik_path_prefix: "{{ matrix_client_element_path_prefix }}"
matrix_client_element_container_labels_traefik_rule: "Host(`{{ matrix_client_element_container_labels_traefik_hostname }}`){% if matrix_client_element_container_labels_traefik_path_prefix != '/' %} && PathPrefix(`{{ matrix_client_element_container_labels_traefik_path_prefix }}`){% endif %}"
matrix_client_element_container_labels_traefik_priority: 0
matrix_client_element_container_labels_traefik_entrypoints: web-secure
matrix_client_element_container_labels_traefik_tls: "{{ matrix_client_element_container_labels_traefik_entrypoints != 'web' }}"
matrix_client_element_container_labels_traefik_tls_certResolver: default  # noqa var-naming

# Controls whether a compression middleware will be injected into the middlewares list.
# This compression middleware is supposed to be defined elsewhere (using labels or a File provider, etc.) and is merely referenced by this router.
matrix_client_element_container_labels_traefik_compression_middleware_enabled: false
matrix_client_element_container_labels_traefik_compression_middleware_name: ""

# Controls which additional headers to attach to all HTTP responses.
# To add your own headers, use `matrix_client_element_container_labels_traefik_additional_response_headers_custom`
matrix_client_element_container_labels_traefik_additional_response_headers: "{{ matrix_client_element_container_labels_traefik_additional_response_headers_auto | combine(matrix_client_element_container_labels_traefik_additional_response_headers_custom) }}"
matrix_client_element_container_labels_traefik_additional_response_headers_auto: |
  {{
    {}
    | combine ({'X-XSS-Protection': matrix_client_element_http_header_xss_protection} if matrix_client_element_http_header_xss_protection else {})
    | combine ({'X-Frame-Options': matrix_client_element_http_header_frame_options} if matrix_client_element_http_header_frame_options else {})
    | combine ({'X-Content-Type-Options': matrix_client_element_http_header_content_type_options} if matrix_client_element_http_header_content_type_options else {})
    | combine ({'Content-Security-Policy': matrix_client_element_http_header_content_security_policy} if matrix_client_element_http_header_content_security_policy else {})
    | combine ({'Permission-Policy': matrix_client_element_http_header_content_permission_policy} if matrix_client_element_http_header_content_permission_policy else {})
    | combine ({'Strict-Transport-Security': matrix_client_element_http_header_strict_transport_security} if matrix_client_element_http_header_strict_transport_security and matrix_client_element_container_labels_traefik_tls else {})
  }}
matrix_client_element_container_labels_traefik_additional_response_headers_custom: {}

# matrix_client_element_container_labels_additional_labels contains a multiline string with additional labels to add to the container label file.
# See `../templates/labels.j2` for details.
#
# Example:
# matrix_client_element_container_labels_additional_labels: |
#   my.label=1
#   another.label="here"
matrix_client_element_container_labels_additional_labels: ''

# A list of extra arguments to pass to the container
matrix_client_element_container_extra_arguments: []

# List of systemd services that matrix-client-element.service depends on
matrix_client_element_systemd_required_services_list: "{{ [devture_systemd_docker_base_docker_service_name] if devture_systemd_docker_base_docker_service_name else [] }}"

# Controls the healthcheck command for the container.
#
# Leave empty to use the default (upstream) command.
matrix_client_element_container_healthcheck_cmd: ""

# Specifies the value of the `X-XSS-Protection` header
# Stops pages from loading when they detect reflected cross-site scripting (XSS) attacks.
#
# Learn more about it is here:
# - https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/X-XSS-Protection
# - https://portswigger.net/web-security/cross-site-scripting/reflected
matrix_client_element_http_header_xss_protection: "1; mode=block"

# Specifies the value of the `X-Frame-Options` header which controls whether framing can happen.
# See: https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/X-Frame-Options
matrix_client_element_http_header_frame_options: SAMEORIGIN

# Specifies the value of the `X-Content-Type-Options` header.
# See: https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/X-Content-Type-Options
matrix_client_element_http_header_content_type_options: nosniff

# Specifies the value of the `Content-Security-Policy` header.
# See: https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Content-Security-Policy
matrix_client_element_http_header_content_security_policy: frame-ancestors 'self'

# Specifies the value of the `Permission-Policy` header.
# See: https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Permission-Policy
matrix_client_element_http_header_content_permission_policy: "{{ 'interest-cohort=()' if matrix_client_element_floc_optout_enabled else '' }}"

# Specifies the value of the `Strict-Transport-Security` header.
# See: https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Strict-Transport-Security
matrix_client_element_http_header_strict_transport_security: "max-age=31536000; includeSubDomains{{ '; preload' if matrix_client_element_hsts_preload_enabled else '' }}"

# Controls whether to send a "Permissions-Policy interest-cohort=();" header along with all responses
#
# Learn more about what it is here:
# - https://www.eff.org/deeplinks/2021/03/googles-floc-terrible-idea
# - https://paramdeo.com/blog/opting-your-website-out-of-googles-floc-network
# - https://amifloced.org/
#
# Of course, a better solution is to just stop using browsers (like Chrome), which participate in such tracking practices.
# See: `matrix_client_element_content_permission_policy`
matrix_client_element_floc_optout_enabled: true

# Controls if HSTS preloading is enabled
#
# In its strongest and recommended form, the [HSTS policy](https://www.chromium.org/hsts) includes all subdomains, and
# indicates a willingness to be "preloaded" into browsers:
# `Strict-Transport-Security: max-age=31536000; includeSubDomains; preload`
# For more information visit:
# - https://en.wikipedia.org/wiki/HTTP_Strict_Transport_Security
# - https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Strict-Transport-Security
# - https://hstspreload.org/#opt-in
# See: `matrix_client_element_http_header_strict_transport_security`
matrix_client_element_hsts_preload_enabled: false

matrix_client_element_scheme: https
# The hostname at which Element Web is served.
matrix_client_element_hostname: "{{ matrix_server_fqn_element }}"

# The path at which Element Web is exposed.
# This value must either be `/` or not end with a slash (e.g. `/element`).
matrix_client_element_path_prefix: /

# Element Web config.json customizations
matrix_client_element_default_server_name: "{{ matrix_domain }}"
matrix_client_element_default_hs_url: ""
matrix_client_element_default_is_url: ~
matrix_client_element_map_style_url: "{{ matrix_client_element_scheme }}://{{ matrix_client_element_hostname }}/map_style.json"
matrix_client_element_disable_custom_urls: true
matrix_client_element_disable_guests: true
matrix_client_element_integrations_ui_url: "https://scalar.vector.im/"
matrix_client_element_integrations_rest_url: "https://scalar.vector.im/api"
matrix_client_element_integrations_widgets_urls: ["https://scalar.vector.im/api"]
matrix_client_element_integrations_jitsi_widget_url: "https://scalar.vector.im/api/widgets/jitsi.html"
matrix_client_element_permalink_prefix: "https://matrix.to"  # noqa var-naming
matrix_client_element_mobile_guide_app_variant: "element"
matrix_client_element_bug_report_endpoint_url: "https://element.io/bugreports/submit"
matrix_client_element_show_lab_settings: true  # noqa var-naming
# Element public room directory server(s)
matrix_client_element_room_directory_servers: ['matrix.org']
# Branding of Element
matrix_client_element_brand: "Element"

# URL to Logo on welcome page
matrix_client_element_welcome_logo: "themes/element/img/logos/element-logo.svg"

# URL of link on welcome image
matrix_client_element_welcome_logo_link: "https://element.io"

matrix_client_element_welcome_headline: "_t(\"welcome_to_element\")"
matrix_client_element_welcome_text: "_t(\"powered_by_matrix_with_logo\")"

# Links, shown in footer of welcome page:
# [{"text": "Link text", "url": "https://link.target"}, {"text": "Other link"}]
matrix_client_element_branding_auth_footer_links: ~  # noqa var-naming

# URL to image, shown during Login
matrix_client_element_branding_auth_header_logo_url: "{{ matrix_client_element_welcome_logo }}"  # noqa var-naming

# URL to Wallpaper, shown in background of welcome page
matrix_client_element_branding_welcome_background_url: ~  # noqa var-naming

# Controls the `features` section of the Element Web configuration.
matrix_client_element_features: "{{ matrix_client_element_features_default | combine(matrix_client_element_features_auto, recursive=True) | combine(matrix_client_element_features_custom, recursive=True) }}"
matrix_client_element_features_default: |-
  {{
    {}

    | combine(
      {'feature_video_rooms': true} if matrix_client_element_features_feature_video_rooms else {}
    )
    | combine(
      {'feature_group_calls': true} if matrix_client_element_features_feature_group_calls else {}
    )
    | combine(
      {'feature_element_call_video_rooms': true} if matrix_client_element_features_feature_element_call_video_rooms else {}
    )
    | combine(
      {'feature_oidc_native_flow': true} if matrix_client_element_features_feature_oidc_native_flow else {}
    )
  }}

matrix_client_element_features_auto: {}
matrix_client_element_features_custom: {}

matrix_client_element_features_feature_video_rooms: false
matrix_client_element_features_feature_group_calls: false
matrix_client_element_features_feature_element_call_video_rooms: false
matrix_client_element_features_feature_oidc_native_flow: false

matrix_client_element_element_call_enabled: false
matrix_client_element_element_call: "{{ matrix_client_element_element_call_default | combine(matrix_client_element_element_call_auto, recursive=True) | combine(matrix_client_element_element_call_custom, recursive=True) }}"
matrix_client_element_element_call_default: |-
  {{
    {}
    | combine(
      {'url': matrix_client_element_element_call_url} if matrix_client_element_element_call_url else {}
    )
    | combine(
      {'participant_limit': matrix_client_element_element_call_participant_limit} if matrix_client_element_element_call_participant_limit else {}
    )
    | combine(
      {'brand': matrix_client_element_element_call_brand} if matrix_client_element_element_call_brand else {}
    )
    | combine(
      {'use_exclusively': matrix_client_element_element_call_use_exclusively} if matrix_client_element_element_call_use_exclusively else {}
    )
  }}
matrix_client_element_element_call_auto: {}
matrix_client_element_element_call_custom: {}

# Controls the `element_call.url` setting in the Element Web configuration.
matrix_client_element_element_call_url: ''

# Controls the `element_call.participant_limit` setting in the Element Web configuration.
matrix_client_element_element_call_participant_limit: 8

# Controls the `element_call.brand` setting in the Element Web configuration.
matrix_client_element_element_call_brand: "Element Call"

# Controls the `element_call.use_exclusively` setting in the Element Web configuration.
matrix_client_element_element_call_use_exclusively: true

matrix_client_element_page_template_welcome_path: "{{ role_path }}/templates/welcome.html.j2"

# By default, there's no Element Web homepage (when logged in). If you wish to have one,
# point this to a `home.html` template file on your local filesystem.
matrix_client_element_embedded_pages_home_path: ~

matrix_client_element_jitsi_preferred_domain: ''  # noqa var-naming

# Controls whether the self-check feature should validate SSL certificates.
matrix_client_element_self_check_validate_certificates: true

# don't show the registration button on welcome page
matrix_client_element_registration_enabled: false

# An optional ISO 3166 alpha2 country code (eg: GB, the default) to use when showing phone number inputs
matrix_client_element_default_country_code: "GB"

# Controls whether presence will be enabled
matrix_client_element_enable_presence_by_hs_url: ~

# Controls whether custom Element Web themes will be installed.
# When enabled, all themes found in the `matrix_client_element_themes_repository_url` repository
# will be installed and enabled automatically.
matrix_client_element_themes_enabled: false
matrix_client_element_themes_repository_url: https://github.com/aaronraimist/element-themes
matrix_client_element_themes_repository_version: master

# Controls the default theme
matrix_client_element_default_theme: 'light'

# Controls the `setting_defaults.custom_themes` setting of the Element Web configuration.
# You can use this setting to define custom themes.
#
# Also, look at `matrix_client_element_themes_enabled` for a way to pull in a bunch of custom themes automatically.
# If you define your own themes here and set `matrix_client_element_themes_enabled: true`, your themes will be preserved as well.
#
# Note that for a custom theme to work well, all Element Web instances that you use must have the same theme installed.
matrix_client_element_setting_defaults_custom_themes: []  # noqa var-naming

# Default Element Web configuration template which covers the generic use case.
# You can customize it by controlling the various variables inside it.
#
# For a more advanced customization, you can extend the default (see `matrix_client_element_configuration_extension_json`)
# or completely replace this variable with your own template.
#
# The side-effect of this lookup is that Ansible would even parse the JSON for us, returning a dict.
# This is unlike what it does when looking up YAML template files (no automatic parsing there).
matrix_client_element_configuration_default: "{{ lookup('template', 'templates/config.json.j2', convert_data=False) | from_json }}"

# Your custom JSON configuration for Element Web should go to `matrix_client_element_configuration_extension_json`.
# This configuration extends the default starting configuration (`matrix_client_element_configuration_default`).
#
# You can override individual variables from the default configuration, or introduce new ones.
#
# If you need something more special, you can take full control by
# completely redefining `matrix_client_element_configuration_default`.
#
# Example configuration extension follows:
#
# matrix_client_element_configuration_extension_json: |
#  {
#  "disable_3pid_login": true,
#  "disable_login_language_selector": true
#  }
matrix_client_element_configuration_extension_json: '{}'

matrix_client_element_configuration_extension: "{{ matrix_client_element_configuration_extension_json | from_json if matrix_client_element_configuration_extension_json | from_json is mapping else {} }}"

# Holds the final Element Web configuration (a combination of the default and its extension).
# You most likely don't need to touch this variable. Instead, see `matrix_client_element_configuration_default`.
matrix_client_element_configuration: "{{ matrix_client_element_configuration_default | combine(matrix_client_element_configuration_extension, recursive=True) }}"

# Element Location sharing functionality
# More info: https://element.io/blog/element-launches-e2ee-location-sharing/
# How to host your own map tile server: https://matrix.org/docs/guides/map-tile-server
matrix_client_element_location_sharing_enabled: false

# Default Element location sharing map style configuration template which covers the generic use case.
# You can customize it by controlling the various variables inside it.
#
# For a more advanced customization, you can extend the default (see `matrix_client_element_location_sharing_map_style_extension_json`)
# or completely replace this variable with your own template.
#
# The side-effect of this lookup is that Ansible would even parse the JSON for us, returning a dict.
# This is unlike what it does when looking up YAML template files (no automatic parsing there).
matrix_client_element_location_sharing_map_style_default: "{{ lookup('template', 'templates/map_style.json.j2', convert_data=False) | from_json }}"

# Your custom JSON configuration for Element location sharing map style should go to `matrix_client_element_location_sharing_map_style_extension_json`.
# This configuration extends the default starting configuration (`matrix_client_element_location_sharing_map_style_default`).
#
# You can override individual variables from the default configuration, or introduce new ones.
#
# If you need something more special, you can take full control by
# completely redefining `matrix_client_element_location_sharing_map_style_default`.
#
# Example configuration override follows:
#
# matrix_client_element_location_sharing_map_style_extension_json: |
#  {
#    "sources": {
#        "localsource": {
#            "tileSize": 512
#        }
#    }
#  }
#
# Example configuration extension follows:
#
# matrix_client_element_location_sharing_map_style_extension_json: |
#  {
#    "sources": {
#        "anothersource": {
#            "attribution": "",
#            "tileSize": 256,
#            "tiles": ["https://anothertile.example.com/{z}/{x}/{y}.png"],
#            "type": "raster"
#        }
#    }
#  }
matrix_client_element_location_sharing_map_style_extension_json: '{}'

matrix_client_element_location_sharing_map_style_extension: "{{ matrix_client_element_location_sharing_map_style_extension_json | from_json if matrix_client_element_location_sharing_map_style_extension_json | from_json is mapping else {} }}"

# Holds the final Element location sharing map style configuration (a combination of the default and its extension).
# You most likely don't need to touch this variable. Instead, see `matrix_client_element_location_sharing_map_style_default`.
matrix_client_element_location_sharing_map_style: "{{ matrix_client_element_location_sharing_map_style_default | combine(matrix_client_element_location_sharing_map_style_extension, recursive=True) }}"

# Example tile servers configuration
# matrix_client_element_location_sharing_map_style_content_sources_localsource_tiles: ["https://tile.example.com/{z}/{x}/{y}.png"]
# or
# matrix_client_element_location_sharing_map_style_content_sources_localsource_tiles: ["https://s1.example.com/{z}/{x}/{y}.png", "https://s2.example.com/{z}/{x}/{y}.png", "https://s3.example.com/{z}/{x}/{y}.png"]
matrix_client_element_location_sharing_map_style_content_sources_localsource_tiles: []

# Map attribution (optional):
# Attribution for OpenStreetMap would be like this:
# matrix_client_element_location_sharing_map_style_content_sources_localsource_attribution: "&copy; <a href=\"https://www.openstreetmap.org/copyright\" target=\"_blank\">OpenStreetMap</a> contributors"
# Leave blank, if map does not require attribution.
matrix_client_element_location_sharing_map_style_content_sources_localsource_attribution: ""

# Optional URL to redirect the user to after they have logged out.
# See https://github.com/element-hq/element-web/blob/develop/docs/config.md#sso-setup
matrix_client_element_logout_redirect_url: ''

# Controls the `ELEMENT_WEB_PORT` environment variable.
matrix_client_element_environment_variable_element_web_port: "{{ matrix_client_element_container_port }}"

# Additional environment variables to pass to the container.
#
# Environment variables take priority over settings in the configuration file.
#
# Example:
# matrix_client_element_environment_variables_extension: |
#   ELEMENT_WEB_PORT=8080
matrix_client_element_environment_variables_extension: ''
